; 20/05/2006 : differente vitesse pour retransmission (9600) et reception
;              (4800) bauds 
; 17/12/2005 : version qui se charge d'ecrire et lire sur la carte selon
;              le cable RS232 soit deconnecte ou connecte'.
; 04/08/2004 : bon entete avec les vecteurs d'IRQs

; REMEMBER DURING TESTS NOT ONLY TO RESET uC BUT ALSO TO SWITCH OFF 
; MMC (otherwise init once to SPI mode and then always errors)

; records 1.2611 points/s (50470 points over 11 hours, 7 min=40020 s

	SS      = 0hb5          ; P3.5 drives slave device's SS pin
        LED     = 0hb3
        CHAN    = 0 		; convert this ADC input channel (0 thru 6)

	MEM0	= 0h30		; RAM locations: MMC address and a counter
	MEM1	= 0h31
	MEM2	= 0h32
	MEM3	= 0h33
	dmpMEM0	= 0h34		; RAM locations: MMC address and a counter
	dmpMEM1	= 0h35
	dmpMEM2	= 0h36
	dmpMEM3	= 0h37

	EADRL=0hc6
	ECON=0hb9
	EDATA1=0hbc
	EDATA2=0hbd
	EDATA3=0hbe
	EDATA4=0hbf
	
        .area code (ABS)
        .org 0h0000
RSTirq: ljmp    MAIN ; 3 bytes
IE0irq: nop nop nop nop nop nop nop nop 
TF0irq: nop nop nop nop nop nop nop nop 
IE1irq: nop nop nop nop nop nop nop nop 
TF1irq: nop nop nop nop nop nop nop nop 
TIirq:  nop nop nop nop nop nop nop nop   ; RI+TI interrupt
TF2irq: nop nop nop nop nop nop nop nop 
ADCirq: setb LED reti nop nop nop nop nop 
ISPirq: nop nop nop nop nop nop nop nop 
PSMirq: nop nop nop nop nop nop nop nop 
TIIirq: nop nop nop nop nop nop nop nop 
WDSirq: nop nop nop nop nop nop nop nop nop nop nop nop nop

;        .area code (ABS)
;        .org 0h0060
MAIN:	
	MOV     RCAP2H,#0hFF ; config UART for 9600 baud
        ; MOV     RCAP2L,#-7   ; 9600
        ; MOV     RCAP2L,#-14  ; 4800 
        MOV     TH2,#0hFF
        ; MOV     TL2,#-7      ; 9600
        ; MOV     TL2,#-14     ; 4800
        MOV     SCON,#0h52
        MOV     T2CON,#0h34

        MOV     0hEF,#0h80   ; power up ADC -- ADCCON1=0hEF
        SETB    0hAF         ; enable interrupts -- EA=0hAF
        SETB    0hAE         ; enable ADC interrupt -- EADC=0hAE

	MOV	P1,#0hF7     ; P1.3=digital input
	CLR     LED          ; turn the LED off/no AD conversion occured yet

	setb    ss
	mov     0h9c,#0h01	; cfg814=0h9C
	; mov     0hF8,#0h31	; SPICON=0hF8
	mov     0hF8,#0h3D	; SPICON=0hF8, CPHA=CPOL=1=>0h3D

;-- START INITALIZING MMC: send 10 times 0xff ----------------------
	MOV     A,#0h0ff        ; send 10 times $ff with SS#=hi
	mov	R0,#0h0a
init:	LCALL	SENDSPI	
	DJNZ	R0,init

    	NOP	
	NOP
	NOP
	
;-- now reset MMC: send 0x40/00/00/00/00/0x95=cmd(00) --------------
	clr     ss		;

        MOV	A,#0h40       	; RESET MMC     
	LCALL	SENDSPI		; 
	
        MOV	A,#0h00       	; RESET MMC: send 4 times '0x00'
	mov	R0,#0h04	; 
rst:	LCALL	SENDSPI		; 
	DJNZ	R0,rst
	
	MOV	A,#0h95		; ... and send CRC
	LCALL	SENDSPI		
	
        NOP
	NOP
	NOP

loop2:	LCALL 	READSPI
	LCALL   SENDCHAR
	CJNE    A,#0h01,loop2	; we only continue if the MMC answers '0x01'

cmd1:	setb    ss
	MOV	A,#0hff
	LCALL	SENDSPI		

	clr     ss		;
	MOV	A,#0h41		; command 0x01 & 0x40
	LCALL	SENDSPI
	MOV	A,#0h00
	LCALL	SENDSPI
	MOV	A,#0		; A,#0hc0
	LCALL	SENDSPI
	MOV	A,#0		; A,#0hff
	LCALL	SENDSPI
	MOV	A,#0h00
	LCALL	SENDSPI
	MOV	A,#0hff
	LCALL	SENDSPI

loop3:	LCALL 	READSPI
	LCALL   SENDCHAR
	CJNE    A,#0h01,SPIok	; we continue as long as MMC answers '0x01'
	SJMP	cmd1		; otherwise MMC should answer 0x00: SPI mode OK
				; AT THIS POINT MMC IS IN SPI MODE
SPIok:	setb    ss
	MOV	A,#0hff
	LCALL	SENDSPI		
	
	LCALL	rdEE
	; on teste le port serie : si niveau haut alors ... sinon ...
	jnb	P1.3,rs232inactif	; branch if bit is 0 (see also jb)
	LJMP	xfer

rs232inactif:
        MOV     RCAP2L,#-14
        MOV     TL2,#-14
	mov	A,#0h4F		; O
	LCALL   SENDCHAR	; 
	mov	A,#0h4B		; K
	LCALL   SENDCHAR

	;lcall	rdEE 		; RAM location 0, 1, 2 and 3 store the address
contadc:mov	A,MEM1 
	LCALL	SENDCHAR	
	mov	A,MEM2
	LCALL	SENDCHAR	
	LCALL	MMCwriteBlock	; write block at address 0
	lcall	wrEE		; sauver l'adresse qui vient d'etre remplie
	inc	MEM1
	inc	MEM1
	mov	A,MEM1
	JNZ	contadc		; jmp if accumulator is not 0
	inc	MEM2
	mov	A,MEM2
	JNZ	contadc
	inc	MEM3
	mov	A,MEM3
	JNZ	contadc

theend:	SJMP	theend

;___________________________________________________________________
; 1/ write command
; 2/ write 4 bytes as the writing address, multiple of 512, MSB firs
; 3/ write $FF (CRC)
; 4/ wait until answer is 0
; 5/ write $FE, followed by 512 bytes and 2x$FF as CRC
; 6/ read answer and check that it finishes with 5 (ie answer=$X5)
; 7/ read while 0 -> continue when answer is non-0 (*** might be $FF
; care of not locking at point 7 ***)
MMCwriteBlock:
	clr     ss		
	MOV	A,#0h58		; command 0d24=0x18 & 0x40
	LCALL	SENDSPI
	MOV	A,MEM3		; hi byte first ...
	LCALL	SENDSPI
	MOV	A,MEM2
	LCALL	SENDSPI
	MOV	A,MEM1
	LCALL	SENDSPI
	MOV	A,MEM0		; ... and lo byte last
	LCALL	SENDSPI
	MOV	A,#0hff		; CRC
	LCALL	SENDSPI
	
	LCALL 	READSPI		; should be 0x00
	LCALL   SENDCHAR

	MOV	A,#0hfe		; answer for writing data
	LCALL	SENDSPI
	mov	R1,#0h02
writ3:	mov	R0,#0h00
writ2:	LCALL   GETCHAR	; ... OR store value received from RS232 port
	CJNE	A,#0h40,pasA	; ajout : on lit ADC si on a '@'=0x40
	JNB	LED,premier	;   LED=1 => conversion done, read 2nd byte
 ; rque : on peut continuer comme ca avec d'autres compteurs pour d'autres ADC
        MOV     A,0hD9          ;   ADCDATAL=0hD9
	CLR	LED		;   reset converter
	SJMP	sauve		;   and save value
premier:;CLR     LED             ;   ... OR read ADC: turn the LED off
        MOV     0hD8,#CHAN      ;   select channel to convert -- ADCCO
        SETB    0hDC            ;   innitiate single ADC conversion --
                                ;   ADC ISR is called upon completion
iciadc: JNB     LED,iciadc
        MOV     A,0hDA          ;   ADCDATAH=0hDA
	sjmp	sauve		;   garde LED a 1 pour le 2eme octet
pasA:	clr	LED		; remet a 0 le compteur de sauvegarde ADC
        ;LCALL   SENDCHAR	;   ici A contient le ADC au lieu de @
sauve:	LCALL 	SENDSPI		; read value
        ;MOV     A,0hD9          ; ADCDATAL=0hD9
	;LCALL 	SENDSPI		; read value
        ;MOV     A,#0h10         ; Delay length
        ;LCALL   DELAY           ; delay 100ms
	DJNZ	R0,writ2
	DJNZ	R1,writ3

	MOV	A,#0hff		; CRC (0xff)
	LCALL	SENDSPI		; x2
	LCALL	SENDSPI
	LCALL 	READSPI		; write response: should finish with 5=ACK

lpwrit:	; mov	R0,#100		; how many retries should we do ?
	LCALL 	READSPI		; read SPI ...
	CJNE	A,#0h00,endwrit	; ... while answer is 0x00
	; DJNZ	R0,lpwrit	; avoid locking MMC in case we miss a '0x00' ?!
	; mov	A,#0hAA		; signature of failed writing: we send
	; LCALL   SENDCHAR	; AA 55
	; mov	A,#0h55
	; LCALL   SENDCHAR
	SJMP	lpwrit
endwrit:setb    ss
	MOV	A,#0hff		; CRC (0xff)
	LCALL	SENDSPI
	RET

;;;;;;;;;;;;;;;;;;;;;;;;;; copie de dumpall ;;;;;;;;;;;;;;;;;;;;;;;
xfer:	
        MOV     RCAP2L,#-7
        MOV     TL2,#-7
mov	A,#0haa
lcall	SENDCHAR
mov	A,#0haa
lcall	SENDCHAR
mov	A,MEM1
lcall	SENDCHAR
mov	A,MEM2
lcall	SENDCHAR
mov	A,MEM3
lcall	SENDCHAR

        mov     dmpMEM0,#0        ; RAM location 0, 1, 2 and 3 store the address
        mov     dmpMEM1,#0        ; 64 or 0
        mov     dmpMEM2,#0
        mov     dmpMEM3,#0
	
	mov	A,MEM1
	jnz	plus2
	mov	A,MEM2
	jnz	plus2
	mov	A,MEM3
	jnz	plus2
	mov	MEM3,#0h01	; si on est arrive ici, MEM1=MEM2=MEM3=0 ie
				; on a fait un reset trop vite => dump 16 MB

plus2:  inc	MEM1		; necessairement paire donc +1 != 0
	inc 	MEM1		; on lira juskau bloc suivant
	mov	A,MEM1
        JNZ     incmem2
	inc	MEM2
	mov	A,MEM2
        JNZ     incmem2
	inc	MEM3
incmem2:

litout: LCALL   MMCreadBlock    ; read block at address 0x00

        inc     dmpMEM1
        inc     dmpMEM1
	lcall	compare
	mov	A,dmpMEM1	; set bit Z
        JNZ     litout
        inc     dmpMEM2
	lcall	compare
	mov	A,dmpMEM2	; set bit Z
        JNZ     litout
        inc     dmpMEM3
	lcall	compare
        sjmp    litout		; au cas ou` ... 

compare:mov	A,MEM3
	CJNE	A,dmpMEM3,pasegal
	mov	A,MEM2
	CJNE	A,dmpMEM2,pasegal
	mov	A,MEM1
	CJNE	A,dmpMEM1,pasegal
	lcall	rmEE			; MEM2{2,3}=dmpMEM{2,3} : fini
	mov	A,#0h45		; E
	LCALL   SENDCHAR	; 
	mov	A,#0h4E		; N
	LCALL   SENDCHAR
	mov	A,#0h44		; D
	LCALL   SENDCHAR
theend2: SJMP    theend2;	fin de dumpall 
pasegal:ret
;____________________________________________________________________
MMCreadBlock:   
        clr     ss              ; 
        MOV     A,#0h51         ; command 0d17=0x11 & 0x40
        LCALL   SENDSPI
        MOV     A,dmpMEM3          ; hi byte first ...
        LCALL   SENDSPI
        MOV     A,dmpMEM2
        LCALL   SENDSPI
        MOV     A,dmpMEM1
        LCALL   SENDSPI
        MOV     A,dmpMEM0          ; ... and lo byte last
        LCALL   SENDSPI
        MOV     A,#0hff         ; CRC
        LCALL   SENDSPI

        LCALL   READSPI         ; should be 0x00
        LCALL   READSPI         ; should be 0xfe

        mov     R1,#0h02        ; here we read 512=2x256 values
read1:  mov     R0,#0h00        ; 
read0:  LCALL   READSPIVAL      ; read value, even if it is 0xFF => we keep
        LCALL   SENDCHAR        ; all values and cannot use READSPI here
        DJNZ    R0,read0
        DJNZ    R1,read1

        LCALL   READSPIVAL              ; read CRC              POURQUOI PAS ?
        LCALL   READSPIVAL              ; read CRC              POURQUOI PAS ?
        setb    ss

        RET

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;___________________________________________________________________
SENDVAL:        ; converts the hex value of A into two ASCII chars,
                ; and then spits these two characters up the UART.
                ; does not change the value of A.

        PUSH    ACC
        SWAP    A
        LCALL   HEX2ASCII
        LCALL   SENDCHAR        ; send high nibble
        POP     ACC
        PUSH    ACC
        LCALL   HEX2ASCII
        LCALL   SENDCHAR        ; send low nibble
        POP     ACC
        RET
;___________________________________________________________________
HEX2ASCII:      ; converts A into the hex character representing the
                ; value of A's least significant nibble

        ANL     A,#0h0F
bbb:    CJNE    A,#0h0A,bbb+3
        JC      IO0030
        ADD     A,#0h07
IO0030: ADD     A,#0h30         ; '0'   
        RET
;___________________________________________________________________
SENDCHAR:       ; sends ASCII value contained in A to UART
        JNB     TI,SENDCHAR     ; wait til present char gone
        CLR     TI              ; must clear TI
        MOV     SBUF,A
        RET
;___________________________________________________________________
SENDSPI:	; sends the content of A to the SPI port
	MOV     0hF7,A        	; trigger data transfer: SPIDAT=0hF7
icispi:	JNB	0hFF,icispi
	CLR	0hFF		; clear ISPI
	RET
;___________________________________________________________________
READSPI:	; sends the content of A to the SPI port
	mov     B,#8		; max of 8 'FF' answers, otherwise continue ...
retry1:	MOV	A,#0hff         ; generate clocks for reception
	LCALL	SENDSPI		

	mov     A,0hF7		; MOV A,SPIDAT: read resulting value
	CJNE    A,#0hff,readend	; we only continue if the MMC answers NOT 0
        DJNZ    B,retry1
	; SJMP	readspi
readend:RET
;___________________________________________________________________
GETCHAR:        ; waits for a single ASCII character to be received
                ; by the UART.  places this character into A.
iciget: JNB     RI,iciget
        MOV     A,SBUF
        CLR     RI
        RET
;___________________________________________________________________
                                                         ; SUBROUTIN
DELAY:                                  ; Delays by 100ms * A
                                        ; 100mSec based on 2.097152M
                                        ; Core Clock 
                                        ; i.e. default ADuC814 Clock

                MOV     R1,A            ; Acc holds delay variable
 DLY0:          MOV     R2,#0h22        ; Set up delay loop0
 DLY1:          MOV     R3,#0hFF        ; Set up delay loop1
ici:            DJNZ    R3,ici          ; Dec R3 & Jump here until R
                DJNZ    R2,DLY1         ; Dec R2 & Jump DLY1 until R
                DJNZ    R1,DLY0         ; Dec R1 & Jump DLY0 until R
                RET                     ; Return from subroutine
;_______ LIRE L'ADRESSE DE DEMARRAGE EN FLASH
rdEE:  mov     EADRL,#0h00     ; EEPROM page (1..159)
       mov     ECON,#0h01      ; read page
       mov     A,EDATA1
       LCALL   SENDCHAR
       mov     MEM0,A
       mov     A,EDATA2
       LCALL   SENDCHAR
       mov     MEM1,A
       mov     A,EDATA3
       LCALL   SENDCHAR
       mov     MEM2,A
       mov     A,EDATA4
       LCALL   SENDCHAR
       mov     MEM3,A
       ret
;_______ ECRIRE L'ADRESSE COURANTE EN FLASH
wrEE:   mov     EADRL,#0h00     ; EEPROM page (0..159)
        mov     EDATA1,MEM0
        mov     EDATA2,MEM1
        mov     EDATA3,MEM2
        mov     EDATA4,MEM3
        mov     ECON,#0h05      ; erase page
        mov     ECON,#0h02      ; write page
	ret


;_______ EFFACER L'ADRESSE COURANTE EN FLASH
rmEE:   mov     EADRL,#0h00     ; EEPROM page (0..159)
        mov     EDATA1,#00
        mov     EDATA2,#00
        mov     EDATA3,#00
        mov     EDATA4,#00
        mov     ECON,#0h05      ; erase page
        mov     ECON,#0h02      ; write page
	ret

;____________________________________________________________________
READSPIVAL:     ; sends the content of A to the SPI port
        MOV     A,#0hff          ; generate clocks for reception
        LCALL   SENDSPI         
        mov     A,0hF7          ; MOV A,SPIDAT: read resulting value
        RET
