#include "aduc.h"

void nothing() {}

int ctoi(char i) {return( (int)i&0x000000ff);}

void run_code(int fd)
{char buf;unsigned char chksum;
 unsigned char num=3   ; // number of data (excluding cmd => 0..24)
 unsigned char cmd=0x55; // 'U'
 buf=0x07;write(fd,&buf,1);DEBUG("(%x)",ctoi(buf));  // 0x07
 buf=0x0E;write(fd,&buf,1);DEBUG("(%x)",ctoi(buf));  // 0x0E
 buf=num+1;write(fd,&buf,1);DEBUG("(%x)",ctoi(buf)); // num data=0d25
 write(fd,&cmd,1);DEBUG("cmd(%x)",ctoi(cmd));        
 chksum=cmd;
 cmd=0;write(fd,&cmd,1);DEBUG("(%x)",ctoi(cmd));     // start @
 cmd=0;write(fd,&cmd,1);DEBUG("(%x)",ctoi(cmd));  
 cmd=0;write(fd,&cmd,1);DEBUG("(%x)",ctoi(cmd));   
 chksum=0-(chksum+num+1);  // 2 complement of sum of data+num of data
 write(fd,&chksum,1);DEBUG("chk(%x)",ctoi(chksum));
 read(fd,&buf,1);if (buf==6) DEBUG(" => OK\n"); 
                        else DEBUG(" => NG(%x)\n",ctoi(buf)); 
}

void erase_all(int fd,unsigned char cmd) /* cmd 'C'=0x43 &'A'=0x41 data+code */
{char buf;unsigned char chksum;
 unsigned char num=0   ; // number of data (excluding cmd => 0..24)
// unsigned char cmd=0x43; // 'C'   SHOULD BE 43 instead of 41
 printf("Erase all: ");fflush(stdout);
 buf=0x07;write(fd,&buf,1);DEBUG("(%x)",ctoi(buf));  // 0x07
 buf=0x0E;write(fd,&buf,1);DEBUG("(%x)",ctoi(buf));  // 0x0E
 buf=num+1;write(fd,&buf,1);DEBUG("(%x)",ctoi(buf)); // num data=0d25
 write(fd,&cmd,1);DEBUG("(%x)",ctoi(cmd));   // 'E' (write data)
 chksum=cmd;
 chksum=0-(chksum+num+1);  // 2 complement of sum of data+num of data
 write(fd,&chksum,1);DEBUG("chk(%x)",ctoi(chksum));
 read(fd,&buf,1);if (buf==6) DEBUG(" => OK\n"); else DEBUG(" => NG\n");
}

void write_code(int fd,FILE* f,unsigned char cmd)   /* cmd='W'=0x57 for code */
{int i;char buf;unsigned char chksum,data[25];      /* 'E'=0x45 for data */
 unsigned char num=4;   // number of data (excluding cmd and address => 0..24)
 unsigned char addr0=0,addr1=0,addr2=0;
 int res=EOF+1;
 printf("Write code:\n");fflush(stdout);
 do {memset(data,0,25);  /* for (i=0;i<num;i++) {data[i]=0;} */ // 0=NOP
     for (i=0;i<num;i++) {
        if (res!=EOF) res=fscanf(f,"%x",&data[i]);
        if (res==EOF) data[i]=0;
        }
   do {
     buf=0x07;write(fd,&buf,1);DEBUG("(%x)",ctoi(buf));  // 0x07
     buf=0x0E;write(fd,&buf,1);DEBUG("(%x)",ctoi(buf));  // 0x0E
     buf=num+1+3;write(fd,&buf,1);DEBUG("(%x)",ctoi(buf)); // num data<=0d25
     write(fd,&cmd,1);DEBUG("(%x)",ctoi(cmd));
     chksum=cmd+num+1+3;
     write(fd,&addr2,1);DEBUG("@(%x)",ctoi(addr2));chksum+=addr2;
     write(fd,&addr1,1);DEBUG("@(%x)",ctoi(addr1));chksum+=addr1;
     write(fd,&addr0,1);DEBUG("@(%x)",ctoi(addr0));chksum+=addr0;
     for (i=0;i<num;i++) {
        write(fd,&data[i],1);DEBUG("(%x)",ctoi(data[i]));chksum+=data[i];}
     chksum=0-(chksum);  // 2 complement of sum of data+num of data
     write(fd,&chksum,1);DEBUG("chk(%x)",ctoi(chksum));
     read(fd,&buf,1);if (buf==6) DEBUG(" => OK\n"); else 
                                 DEBUG(" => NG(%x)\n",ctoi(buf));
   } while (buf!=6);
   if (addr0<0xfc) addr0+=4; else {addr1+=1;addr0=0;}
 } while (res!=EOF);
}

void run_aduc(int fd)
{char buf[2];
 buf[0]=0x28;write(fd,buf,1);DEBUG("cmd(%x)",ctoi(buf[0]));            // RUN
 read(fd,buf,2);DEBUG("-> %x %x ; ",ctoi(buf[0]),ctoi(buf[1]));
}

void listen_aduc(int fd)
{int i;char buf;
 for (i=0;i<25;i++)
 {read(fd,&buf,1);
  if ((buf>31) && (buf<127)) DEBUG("%c",buf); else DEBUG(" 0x%d ",ctoi(buf));}
 printf("\nAnd now the ADuC answers ... (should be the same as above)\n");
}

void init_aduc(int fd)
{int i;char buf;
 buf=0x21;write(fd,&buf,1);
 buf=0x5A;write(fd,&buf,1);
 buf=0x00;write(fd,&buf,1);
 buf=0xA6;write(fd,&buf,1);
 for (i=0;i<25;i++)
 {read(fd,&buf,1);
  if ((buf>31) && (buf<127)) DEBUG("%c",buf); else DEBUG(" 0x%d ",ctoi(buf));}
 printf("\n");
}
